# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .data import Data
from .embeddings_response_encoding_format import EmbeddingsResponseEncodingFormat
from .object_type import ObjectType
from .usage import Usage

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class EmbeddingsResponse(pydantic.BaseModel):
    data: Data = pydantic.Field(description="The created embeddings")
    dimensions: typing.Optional[int]
    encoding_format: EmbeddingsResponseEncodingFormat
    model: str = pydantic.Field(description="The model used")
    normalized: bool = pydantic.Field(description="Whether the embeddings are normalized")
    object: typing.Optional[ObjectType] = pydantic.Field(description="The object type of the response")
    usage: Usage = pydantic.Field(description="The usage of the model")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
