# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .multiple_encodings_embedding_item import MultipleEncodingsEmbeddingItem
from .object_type import ObjectType

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class MultipleEncodingsEmbedding(pydantic.BaseModel):
    embedding: MultipleEncodingsEmbeddingItem = pydantic.Field(
        description="The encoded embedding data by encoding format. Returned, if more than one encoding format is used."
    )
    index: int = pydantic.Field(description="The index of the embedding")
    object: typing.Optional[ObjectType] = pydantic.Field(description="The object type of the embedding")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
