# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .object_type import ObjectType
from .ranked_document import RankedDocument
from .usage import Usage

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class RerankingResponse(pydantic.BaseModel):
    data: typing.List[RankedDocument] = pydantic.Field(description="The ranked documents")
    model: str = pydantic.Field(description="The model used")
    object: typing.Optional[ObjectType] = pydantic.Field(description="The object type of the response")
    return_input: bool = pydantic.Field(description="Whether to return the documents")
    top_k: int = pydantic.Field(description="The number of documents to return")
    usage: Usage = pydantic.Field(description="The usage of the model")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
